#include <bits/stdc++.h>
using namespace std;
#define ios ios::sync_with_stdio(false); cin.tie(NULL);cout.tie(NULL);
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define fr first
#define sc second
#define endl "\n"
#define ll long long
#define int ll
void fopn(string name){
	freopen((name+".in").c_str(),"r",stdin);
	freopen((name+".out").c_str(),"w",stdout);
}
const ll N=2e5+5,INF=1e18,mod=1e9+7;
int dp[N][2];
void solve(){
	int n;cin>>n;
	vector<int> h(n),c(n);
	for(int i=0;i<n;i++)
		cin>>h[i];
	for(int i=0;i<n;i++)
		cin>>c[i];
	stack<pair<int,int>> st;
	for(int i=0;i<n;i++){
		if(st.empty()){
			st.push({h[i],i});
			dp[i][0]=c[i];
			continue;
		}
		while(!st.empty() && st.top().fr<h[i]){
			st.pop();
		}
		if(!st.empty()){
			dp[i][0]=dp[st.top().sc][0]+c[i];
			if(st.top().sc>0)
				dp[i][0]=min(dp[i][0],dp[st.top().sc-1][0]+c[st.top().sc]);
		}
		else{
			dp[i][0]=c[i];
		}
		st.push({h[i],i});
	}
	while(!st.empty()) st.pop();
	for(int i=n-1;i>=0;i--){
		if(st.empty()){
			st.push({h[i],i});
			dp[i][1]=c[i];
			continue;
		}
		while(!st.empty() && st.top().fr<h[i]){
			st.pop();
		}
		if(!st.empty()){
			dp[i][1]=dp[st.top().sc][1]+c[i];
			if(st.top().sc<n-1)
				dp[i][1]=min(dp[i][1],dp[st.top().sc+1][1]+c[st.top().sc]);
		}
		else{
			dp[i][1]=c[i];
		}
		st.push({h[i],i});
	}
	int ans=min(dp[0][1],dp[n-1][0]);
	for(int i=0;i<n-1;i++) ans=min(ans,dp[i][0]+dp[i+1][1]);
	/*for(int i=0;i<n;i++)
		cout<<dp[i][0]<<' ';
	cout<<endl;
	for(int i=0;i<n;i++)
		cout<<dp[i][1]<<' ';
	cout<<endl;*/
	cout<<ans;
	
}
main(){
	//ios;
	int T=1;
	//cin>>T;
	for(int i=1;i<=T;i++){
		//cout<<"Case #"<<i<<": ";
		solve();
	}
}

